﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Input;
using Telerik.Windows.Controls;
using Telerik.Windows.Controls.GridView;

namespace RadGridView_WPF_AR_37
{
    class CustomKeyboardCommandProvider : DefaultKeyboardCommandProvider
    {

        GridViewDataControl _parentGrid;
        bool _firstEnterHandled;

        public CustomKeyboardCommandProvider(GridViewDataControl grid): base (grid)
        {
            this._parentGrid = grid;
        }

        public override IEnumerable<ICommand> ProvideCommandsForKey(Key key)
        {
            List<ICommand> commandsToExecute = base.ProvideCommandsForKey(key).ToList();

            if (_parentGrid.RowInEditMode != null)
            {
                if (key == Key.Enter && _parentGrid.CurrentCell.Column == _parentGrid.Columns[_parentGrid.Columns.Count - 1])
                {
                    if (_firstEnterHandled == false)
                    {
                        _firstEnterHandled = true;
                        commandsToExecute.Clear();
                        commandsToExecute.Add(RadGridViewCommands.CommitCellEdit);
                        commandsToExecute.Add(RadGridViewCommands.SelectCurrentUnit);  // DOESNT WORK

                    }
                    else
                    {
                        if (_parentGrid.SelectedItem  == (_parentGrid.ItemsSource as ObservableCollection<Club>).LastOrDefault())
                        {
                            commandsToExecute.Clear();
                            _parentGrid.BeginInsert();

                        }
                        else
                        {
                            commandsToExecute.Clear();
                            commandsToExecute.Add(RadGridViewCommands.MoveNext);
                            commandsToExecute.Add(RadGridViewCommands.BeginEdit);
                        }

                        /* Reset flag */
                        _firstEnterHandled = false;

                    }
                }
                else 
                {
                    commandsToExecute.Clear();
                    commandsToExecute.Add(RadGridViewCommands.CommitCellEdit);
                    commandsToExecute.Add(RadGridViewCommands.MoveNext);
                    commandsToExecute.Add(RadGridViewCommands.BeginEdit);

                    _firstEnterHandled = false;
                }
            }
           
           
          
            return commandsToExecute;
        }
    }
}
